# -*- encoding: utf-8 -*-
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require "lazy_string"

Gem::Specification.new do |gem|
  gem.name = 'lazy_string'
  gem.version = LazyString::VERSION
  gem.authors = ['Aaron Beckerman']
  gem.description = %q{This library provides LazyString, a class for computing strings only when necessary -- that is, when #to_str or #to_s is called. This is useful when computing the string is expensive but the string is unlikely to be used: an error message passed as a method argument, for example.}
  gem.summary = %q{A Ruby library for lazily computing strings.}
  gem.license = 'MIT'
  gem.required_ruby_version = '>= 1.8.7'

  gem.files = %w{LICENSE.txt README.txt lazy_string.gemspec lib/lazy_string.rb test/lazy_string_test.rb}
  gem.executables = %w{}
  gem.test_files = %w{test/lazy_string_test.rb}
  gem.require_paths = %w{lib}
end
