require 'lazy_string'

Class == LazyString.class or fail

String == LazyString::VERSION.class or fail

lambda do
  obj = Object.new
  LazyString.new { obj.freeze }
  !obj.frozen? or fail
end.call

LazyString.new.respond_to?(:to_str) or fail

LazyString.new.respond_to?(:to_s) or fail

'' == LazyString.new.to_str or fail

lambda do
  obj = Object.new
  def obj.to_str; 'to_str' end
  def obj.to_s; 'to_s' end
  'to_str' == LazyString.new { obj }.to_str or fail
end.call

lambda do
  obj = Object.new
  def obj.to_s; 'to_s' end
  !obj.respond_to?(:to_str) or fail
  'to_s' == LazyString.new { obj }.to_str or fail
end.call

'42' == LazyString.new { 2 * 21 }.to_s or fail

lambda do
  arr = []
  ls = LazyString.new { arr << nil; 'foo' }
  ls.to_str
  'foo' == ls.to_str or fail
  1 == arr.length or fail
end.call

lambda do
  ex = StandardError.new
  ls = LazyString.new { raise(ex) }
  begin
    ls.to_str
  rescue
    ex.equal?($!) or fail
  else
    fail
  end
end.call

puts 'Test finished.'
